#!/bin/bash

# Usage:  'contextMenu.sh install [vesta path] [icon path]' or 'install.sh remove'
# vesta path - absolute path to vesta application
# icon path - abolute path to icon
# Note: this script requires appIcon.png near itself.



    #check root:

if [[ $EUID -ne 0 ]];
then
    echo "You must be root"
    exit 1
fi;

kde=0


    #searching for kde services path:

kdePath=$(kf5-config --path services)
if [ $? -eq 0 ];
then 
    index=$(expr index $kdePath :)
    kdePath=${kdePath:$index}
    kde=1
else
    kdePath=/usr/share/kservices5
fi

if [ -z $kdePath ];
then
    echo "Can not fild kde services path"
    exit 11
fi
kdePath=$kdePath/ServiceMenus


if [ "$1" = "install" ];                                                                    ###install:
then
        #check vesta path:
        
    vestaPath=$(realpath vesta)
    if [ ! -z "$2" ]
    then
        vestaPath=$(realpath $2)
    fi
    if [ ! -f $vestaPath ];
    then
        echo "Can not find vesta application"
        echo "You can specify it by the second argument:"
        echo "contextMenu.sh install [vesta path] [icon path]"
        exit 20
    fi
    
    
        #check icon:
        
    appIcon=$(realpath appIcon.png)
    if [ ! -z "$3" ]
    then
        appIcon=$(realpath $3)
    fi
    if [ ! -f $appIcon ];
    then
        echo "Can not find appIcon.png"
        echo "You can specify it by the third argument"
        echo "contextMenu.sh install [vesta path] [icon path]"
        exit 21
    fi


        #working:
        
    ln -fs "$vestaPath" /usr/bin/vesta
    if [ $? -ne 0 ];
    then
        echo "Error"
        exit 30
    fi
        
    echo "[Desktop Entry]
Type=Application
Encoding=UTF-8
Name=Веста-В
Icon=$appIcon
Exec=$vestaPath \"%F\"
Categories=Mail;Send;Веста;Vesta;
" > /usr/share/applications/vesta.desktop
    if [ $? -ne 0 ];
    then
        echo "Error"
        exit 31
    fi
    
    #kde:
    
    if [ $kde -eq 1 ];
    then
        echo "[Desktop Entry]
Type=Service
Icon=$appIcon
X-KDE-ServiceTypes=KonqPopupMenu/Plugin
MimeType=all;allfiles;
Actions=vesta3;
Encoding=UTF-8

[Desktop Action vesta3]
Name=Отправить через Весту
Icon=$appIcon
Exec=$vestaPath \"%F\"" > $kdePath/vesta.desktop
        if [ $? -ne 0 ];
        then
            echo "Error"
            exit 32
        fi
    fi
    
    for d in /home/*; do
        if [ -d $d ];
        then
                #nautilus:
                
            if [ -d $d/.local/share/nautilus/scripts ]; 
            then
                scriptPath="$d/.local/share/nautilus/scripts/Отправить через Весту"
                echo "$vestaPath \$1" > "$scriptPath"
                if [ $? -ne 0 ];
                then
                    echo "Error"
                    exit 33
                fi
                chmod a+rwx "$scriptPath"
                if [ $? -ne 0 ];
                then
                    echo "Error"
                    exit 34
                fi
            fi
            
                #caja:
                
            if [ -d $d/.config/caja/scripts ]; 
            then
                scriptPath="$d/.config/caja/scripts/Отправить через Весту"
                echo "$vestaPath \$1" > "$scriptPath"
                if [ $? -ne 0 ];
                then
                    echo "Error"
                    exit 35
                fi
                chmod a+rwx "$scriptPath"
                if [ $? -ne 0 ];
                then
                    echo "Error"
                    exit 36
                fi
            fi
            
                #fly toolbar:
                
            if [ -d $d/.fly/toolbar ]; 
            then
                echo "[Desktop Entry]
Type=Application
Encoding=UTF-8
Name=Веста-В
Icon=$appIcon
Exec=$vestaPath \"%F\"
Categories=Mail;Send;Веста;Vesta;
" > $d/.fly/toolbar/vesta.desktop
                if [ $? -ne 0 ];
                then
                    echo "Error"
                    exit 37
                fi
            fi
        fi
    done
    
    #fly toolbar:
    
    for d1 in /home/.pdp/*; do
        if [ -d $d1 ];
        then
            for d2 in $d1/*; do
                if [ -d $d2 ];
                then
                    if [ -d $d2/.fly/toolbar ];
                    then
                        echo "[Desktop Entry]
Type=Application
Encoding=UTF-8
Name=Веста-В
Icon=$appIcon
Exec=$vestaPath \"%F\"
Categories=Mail;Send;Веста;Vesta;
" > $d2/.fly/toolbar/vesta.desktop
                        if [ $? -ne 0 ];
                        then
                            echo "Error"
                            exit 38
                        fi
                    fi
                fi
            done
        fi
    done
    
    #fly fm:
    
    if [ -d /usr/share/flyfm ]; 
    then
        mkdir -p /usr/share/flyfm/actions
        
        echo "[Desktop Entry]
Type=Application
Encoding=UTF-8
MimeType=application/font-sfnt;application/java-archive;application/msword;application/pdf;application/rar;application/rtf;application/xml;application/gzip;application/zip;application/vnd.debian.binary-package;application/vnd.ms-powerpoint;application/vnd.ms-powerpoint.presentation.macroEnabled.12;application/vnd.ms-word.document.macroEnabled.12;application/vnd.oasis.opendocument.chart;application/vnd.oasis.opendocument.database;application/vnd.oasis.opendocument.formula;application/vnd.oasis.opendocument.graphics;application/vnd.oasis.opendocument.presentation;application/vnd.oasis.opendocument.spreadsheet;application/vnd.oasis.opendocument.text;application/x-7z-compressed;application/x-bittorrent;application/x-debian-package;application/x-gtar-compressed;application/x-tar;application/x-sql;audio/mpeg;audio/ogg;audio/x-wav;image/gif;image/jpeg;image/tiff;image/vnd.djvu;image/x-ms-bmp;text/csv;text/html;image/png;text/plain;video/mpeg;video/mp4;video/webm;video/x-flv;video/x-msvideo;video/x-matroska;
Actions=vesta3

[Desktop Action vesta3]
Name=Отправить через Весту
Icon=$appIcon
Exec=$vestaPath \"%F\"" > /usr/share/flyfm/actions/vesta.desktop
    fi
    
    #xfce:
    
    if [ -d /usr/share/Thunar/sendto ];
    then
          echo "[Desktop Entry]
Type=Application
Encoding=UTF-8
Name=Отправить через Весту
Icon=$appIcon
Exec=$vestaPath \"%F\"
" > /usr/share/Thunar/sendto/vesta.desktop
        if [ $? -ne 0 ];
        then
            echo "Error"
            exit 39
        fi
    fi
    
    
    echo "Successfully installed"
    exit 0
elif [ "$1" = "remove" ];                                                                   ###remove:
then
    rm -f /usr/bin/vesta
    if [ $? -ne 0 ];
    then
        echo "Error"
        exit 40
    fi
    
    if [ $kde -eq 1 ];
    then
        rm -f $kdePath/vesta.desktop
        if [ $? -ne 0 ];
        then
            echo "Error"
            exit 41
        fi
    fi
    
    rm -f /usr/share/applications/vesta.desktop
    if [ $? -ne 0 ];
    then
        echo "Error"
        exit 42
    fi
    
    for d in /home/*; do
        if [ -d $d ];
        then
                #nautilus:
            scriptPath="$d/.local/share/nautilus/scripts/Отправить через Весту"
            rm -f "$scriptPath"
            if [ $? -ne 0 ];
            then
                echo "Error"
                exit 43
            fi
            
                #caja:
            scriptPath="$d/.config/caja/scripts/Отправить через Весту"
            rm -f "$scriptPath"
            if [ $? -ne 0 ];
            then
                echo "Error"
                exit 44
            fi
            
                #fly:
            rm -f $d/.fly/toolbar/vesta.desktop
            if [ $? -ne 0 ];
            then
                echo "Error"
                exit 45
            fi
        fi
    done
    
        #fly toolbar:
    for d1 in /home/.pdp/*; do
        if [ -d $d1 ];
        then
            for d2 in $d1/*; do
                if [ -d $d2 ];
                then
                    if [ -d $d2/.fly/toolbar ];
                    then
                        rm -f $d2/.fly/toolbar/vesta.desktop
                    if [ $? -ne 0 ];
                    then
                        echo "Error"
                        exit 46
                    fi
                    fi
                fi
            done
        fi
    done
    
    rm -f /usr/share/Thunar/sendto/vesta.desktop
    if [ $? -ne 0 ];
    then
        echo "Error"
        exit 47
    fi
    
    echo "Successfully removed"
    exit 0
else
    echo "Usage: 'contextMenu.sh install [vesta path] [icon path]' or 'install.sh remove'"
    exit 90
fi

echo "Unknown Error"
exit 100
